



#define PWM_INF_MESSAGE  (WM_USER +1)

#define STATE_NOT_CONNECTED 0
#define STATE_CONNECTING    1
#define STATE_CONNECTED     2

#define CONNECTION_PVC     0
#define CONNECTION_SVC_OUT 1
#define CONNECTION_SVC_IN  2

#define QOS_UBR 0
#define QOS_CBR 1
#define QOS_VBR 2
#define QOS_ABR 4

#define  NO_GROUP              0
#define  ZERO_FLAGS            0
#define  NULL_SOCKET          -1
#define  FAIL                 -1
#define  SUCCESS               1


#define LAYER_AAL5 0
#define LAYER_AAL0 1

typedef struct _SVC_SETTINGS
{
    union
    {
        char ServerAddress[20];
        char Selector;
    };
 

}SVC_SETTINGS, *PSVC_SETTINGS;

typedef struct _PVC_SETTINGS
{
    unsigned int Vpi;
    unsigned int Vci;
	unsigned int Gfc;
	unsigned int Pt; 
	unsigned int Clp;

}PVC_SETTINGS, *PPVC_SETTINGS;



typedef struct _UBR_SETTINGS
{
    unsigned long PeakCellRate;    

} UBR_SETTINGS, *PUBR_SETTINGS;

typedef struct _CBR_SETTINGS
{
    unsigned long PeakCellRate;    

} CBR_SETTINGS, *PCBR_SETTINGS;

typedef struct _VBR_SETTINGS
{
    unsigned long PeakCellRate;
    unsigned long SubstainableCellRate;
    unsigned long MaxBurstSize;        

}VBR_SETTINGS, *PVBR_SETTINGS;

typedef struct _ABR_SETTINGS
{
    unsigned long PeakCellRate;
    unsigned long MinimumCellRate;
    unsigned long AllowedCellRate;
    unsigned long InitialCellRate;
    unsigned long RateIncreaseFactor;
    unsigned long RateDecreaseFactor;
    unsigned long CuttofDecreaseFactor;

}ABR_SETTINGS;


typedef struct _QOS_SETTINGS
{

    union
    {
        UBR_SETTINGS Ubr;
        CBR_SETTINGS Cbr;
        VBR_SETTINGS Vbr;
        ABR_SETTINGS Abr;
    };

}QOS_SETTINGS, *PQOS_SETTINGS;

typedef struct _VC_SETTINGS
{
    union
    {
        SVC_SETTINGS Svc;
        PVC_SETTINGS Pvc;
    };

}VC_SETTINGS, P_VC_SETTINGS;
 
typedef struct _ATM_SETTINGS
{
    int DeviceNumber;
    int VcType;
    VC_SETTINGS VcSettings;
    int QualityOfServices;
    BOOL SetQosSettings;
    QOS_SETTINGS QosSettings;
    int AalType;
    BOOL XmitFlow;
    BOOL ReceiveFlow;
    UINT PacketSize;
	BOOL bLoopbackMode;
} ATM_SETTINGS, *PATM_SETTINGS;


#include <winsock2.h>	// Windows and Winsock2 defines

#define MAX_RECV_PACKETS 63
#define MAX_SEND_PACKETS 4

typedef struct _CONNECTION_INFO
{
	HANDLE		Socket;
	PATM_ADAPTER pAdapter;
    int         DeviceNumber;
    int         VcType;
	int			Vpi;
	int			Vci;
	int         AALLayer;
	int         Gfc;
	int         Pt;
	int         Clp;
    HANDLE      WaitCallThreadHandle;
    DWORD       WaitCallThreadID;
    HANDLE      WaitCallCloseEvent;
    BYTE        LocalATMAddress[20];
    BYTE        RemoteATMAddress[20];
    WSAEVENT    hAccept;      // Accept event handle
	int			ConnectionState;
    UINT        PacketSize;
	int         RecvMode;   /* ON or OFF */
	DWORD       RecvCellHeader;
    HANDLE      RecvThreadHandle;
    DWORD       RecvThreadID;
	WSABUF	    RecvPacket[MAX_RECV_PACKETS];
    OVERLAPPED  RecvOverlapped[MAX_RECV_PACKETS+1];
    HANDLE	    hRecvEventList[MAX_RECV_PACKETS +1];
	BOOL        WaitReceive[MAX_RECV_PACKETS];
    HANDLE      RecvCloseEvent;
	int			RecvSeq;	/* Sequence no. of the next packet (expected) */
	int         XmitMode;   /* ON or OFF */
	HANDLE      XmitThreadHandle;
    DWORD       XmitThreadID;
    WSABUF      XmitPacket[MAX_SEND_PACKETS];
	OVERLAPPED  XmitOverlapped[MAX_SEND_PACKETS+1];
    HANDLE	    hXmitEventList[MAX_SEND_PACKETS+1];
    HANDLE      XmitCloseEvent;
 	int			pktDrop;	/* no. of packets dropped */
    int         pktRecv;
    int         pktXmit;
    int			bytesRecv;
    int			bytesXmit; 
	HWND        DialogHandle;   // Handle of the View Application

}CONNECTION_INFO, *PCONNECTION_INFO;

typedef struct _PACKET_HEADER
{
	int         seq;
	int         len;
}PACKET_HEADER, *PPACKET_HEADER;

typedef struct _AAL0_CELL
{
	DWORD	CellHeader;
	UCHAR   Payload[48];
}  AAL0_CELL, *PAAL0_CELL;

//////typedef struct _ERROR_MESSAGE
//////{
//////    BOOL Valid;
//////    char Message[1024];
//////
//////}ERROR_MESSAGE, *PERROR_MESSAGE;
//////
//////extern ERROR_MESSAGE ErrorMessage;
//////
//////#define CLEAR_MESSAGE() \
//////    ErrorMessage.Valid = FALSE;
//////
//////#define THROW_MESSAGE(s,n ) \
//////ErrorMessage.Valid = TRUE; sprintf(ErrorMessage.Message, s, n);
//////
//////#define CATCH_MESSAGE() \
//////if(ErrorMessage.Valid == TRUE) {AfxMessageBox( ErrorMessage.Message,MB_OK); CLEAR_MESSAGE();}


BOOL GetATMDevices(PATM_ADAPTER pAdapters, DWORD *pDeviceCount);
BOOL SockGetLocalATMAddress(int DeviceNumber,BYTE *pLocalATMAddress);
BOOL SockStartATMConnection(PATM_SETTINGS pSettings,HWND DialogHandle);
void SockStopATMConnection();
